# Changelog

All notable changes to this project will be documented in this file.

## [0.9.0] - 2024-12-03

### Features

- Impl Deserialize on custom types in utils

### Miscellaneous Tasks

- Fix clippy lints
- Update dependencies
- Update changelog and bump versions

## [0.8.1] - 2024-04-16

### Bug Fixes

- Use a fixed version for prometheus-http-query dependency

### Miscellaneous Tasks

- Fix clippy lints
- Bump version to 0.8.1

## [0.8.0] - 2024-01-09

### Bug Fixes

- Make Offset fields pub

### Features

- Subquery support
- Timestamp and label_set fns
- Keep_metric_names modifier
- MetricsQL alias fn

### Miscellaneous Tasks

- Bump version to 0.8.0
- Generate changelog for v0.8.0

### Testing

- Integration tests for label_set and timestamp

## [0.7.1] - 2024-01-05

### Miscellaneous Tasks

- Bump ver to 0.7.1

### QoL Enhancements

- Impl Copy on QryFunc and Clone on AggrFunc

## [0.7.0] - 2024-01-02

### Bug Fixes

- RawExpr methods should be public
- Query helper func should use the new into_result method

### Features

- QueryExt trait for extended builder API functionality

### Miscellaneous Tasks

- Bump version to 0.7.0
- Generate changelog for v0.7.0

### QoL Enhancements

- Impl Operable on references of Operable types as well

### Testing

- Improve tests

## [0.6.0] - 2023-12-29

### Features

- Query_raw method that returns a raw response

### Miscellaneous Tasks

- Bump ver to 0.6.0
- Fix git cliff config for qol group
- Generate changelog for v0.6.0

### QoL Enhancements

- Raw expression type to allow strings in the builder API 

## [0.5.1] - 2023-12-28

### Bug Fixes

- Remove static bounds on query fn params

### Miscellaneous Tasks

- Bump version to 0.5.1

## [0.5.0] - 2023-12-27

### Documentation

- Update README

### Features

- Initial support for handling multiple queries
- Add support for more functions (transform)

### Miscellaneous Tasks

- Bump version to 0.5.0
- Generate changelog for v0.5.0

### Refactor

- Separate fn name and args formatting in QryFunc

## [0.4.0] - 2023-12-26

### Bug Fixes

- Correct Sealed trait's visibility

### Documentation

- Updates and fixes

### Features

- Initial functions support in the query builder API
- Initial impl of promql validation macro

### Miscellaneous Tasks

- Bump version to 0.3.1
- Generate changelog for v0.4.0
- Bump version to 0.4.0

### Refactor

- Remove an error variant that is never used

## [0.3.0] - 2023-12-19

### Bug Fixes

- Make Duration struct's fields public

### Documentation

- Update and add missing docs
- Update README

### Features

- Basic metric query selector/builder
- Binary Operators with Vector Matching
- Type conversion utilities with parallel processing

### Miscellaneous Tasks

- Update README
- Simple code example in README
- Fix typo in README
- Bump prometheus-http-query to 0.8.0
- Bump version to v0.2.0
- Include cliff.toml
- Generate changelog for v0.2.0
- Use latest rust images
- Add tags
- Include clippy component for linting
- Bump version to 0.3.0
- Generate changelog for v0.3.0

### Refactor

- Replace external error type with an internal one in pub API
- Replace external PromqlResult type with internal Data type

<!-- generated by git-cliff -->
